init python:
    class registerClick(Action):
        def __call__(self):
            global num_clicks
            num_clicks += 1
            #hidden_time = 1
#            renpy.restart_interaction()
            
    class getHint(Action):
        def __call__(self):
            global num_hints
            num_hints -= 1
            for index,i in enumerate(hidden_items):
                if i.found == False and i.hint == False:
                    i.hint = True
                    break
            renpy.restart_interaction()
            
        def get_sensitive(self):
            global num_hints
            return num_hints > 0
            
    class SetItem(Action):

        def __init__(self, object, field, value):
            self.object = object
            self.field = field
            self.value = value
        
        def __call__(self):
            setattr(self.object, self.field, self.value)
            renpy.restart_interaction()

        def get_selected(self):
            return getattr(self.object, "hint") == True
            
    class ItemHidden:
        #def __init__(self, name, x,y,w,h,hint=False):
        def __init__(self, name, hint_name="", desc="", key=False, hint=False):
            self.name = name
            self.hint_name = hint_name
            if self.hint_name == "":
                self.hint_name = self.name
            self.desc = desc
            self.key = key            
            self.found = False
            self.hint = hint
            
    showitems = False
    desc = ""
    def display_items_overlay():
        if showitems:
            ui.frame(id="obj_list")
            ui.vbox(id="display_vbox",spacing=10)
            #ui.text("Hints: %d" % (num_hints))
            ui.text("Items:" )
            for index,i in enumerate(hidden_items):
                if i.key:
                    inventory_prefix = ""
                    inventory_suffix = ""
                    item_name = i.hint_name
                    item_state = i.found
                    if item_state == True:
                        inventory_prefix = "{s}"
                        inventory_suffix = "{/s}"
                    item_text = inventory_prefix+item_name+inventory_suffix
                    item_index = "object_%d" % (index)
                    ui.text(item_text,id=item_index)
            elapsed = round(renpy.time.time() - start) + num_clicks * 15
            #ui.text("Time: %d" % (elapsed))
            ui.text(desc)
            
            #ui.text("Paranoia: %d" % (elapsed10))
            
            ui.close()
    config.overlay_functions.append(display_items_overlay)
    
    def is_all_found():
        for i in hidden_items:
            if i.key and i.found == False:
                return False
        return True
        
    def resetItems(in_items):
        for i in in_items:
            i.found = False
    
    # hidden_time = 0
    # def timerHidden():
        # if hidden_time>0:
            # elapsed = round(renpy.time.time() - start)
            # if elapsed > hidden_time:
                # ui.textbutton("Game Over!", clicked=ui.returns("Game Over"), xalign=0.5, yalign=0.5)
    # config.overlay_functions.append(timerHidden)
    
init:
    python:
        # This function will run a countdown of the given length. It will
        # be white until 5 seconds are left, and then red until 0 seconds are
        # left, and then will blink 0.0 when time is up. 
        def countdown(st, at, length=0.0):
            remaining = length - st - num_clicks * 15
            if remaining > 2.0:
                return Text("%.1f" % remaining, color="#fff", size=72), .1
            elif remaining > 0.0:
                return Text("%.1f" % remaining, color="#f00", size=72), .1
            else:
                renpy.hide_screen("hidden")
                renpy.jump('game_over')
#                return anim.Blink(Text("0.0", color="#f00", size=72)), None

    # Show a countdown for 10 seconds.
    image countdown5 = DynamicDisplayable(countdown, length=5.0)    
    image countdown60 = DynamicDisplayable(countdown, length=60.0)    
    
screen item_description (desc=""):
    frame xpos 0.5 ypos 0.1 background Frame("gui/frame.png",25,25) xmargin 25 ymargin 25:
        text desc xpos 0.5
    $ num_clicks += 1
    
screen hidden_object:
    tag hidden
    imagebutton auto "items/empty_%s.png" action registerClick()
    $ num_clicks_plus = num_clicks + 1
    for index, item in enumerate(hidden_items):
        $ item_filename = "items/" + item.name + ".png"
        if not item.found or not item.key:
            imagebutton idle item_filename hover item_filename xpos 0 ypos 0 focus_mask True action [If(hidden_items[index].found==False, [SetItem(hidden_items[index],"found",True), SetVariable("desc", item.desc)], None), If(hidden_items[index].key==False, SetVariable("num_clicks", num_clicks_plus), None)]
    if file_overlay:
        add file_overlay xpos 0 ypos 0
# ShowTransient("item_description", desc=item.desc)
#    if is_all_found():
#        #textbutton "Objects found!" xalign 0.5 yalign 0.5 action Return("All Found!")
#        textbutton "Objects found!" xalign 0.5 yalign 0.5 action Hide("hidden_object")
    #timer hidden_time action Return("Game Over")
        
    